﻿/**Begin D:\PDM_UPGRADE\PDM1\EVP_constraint.sql **/
 EXEC P_ALTERPK 'PK_T_EVP_BKRSENTRY', 'T_EVP_BKRSENTRY', 'FENTRYID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_BKRSENTRY_FID') CREATE INDEX IDX_EVP_BKRSENTRY_FID ON T_EVP_BKRSENTRY ( FID );


 EXEC P_ALTERPK 'PK_T_EVP_ELEVOUCHERTYPE_L', 'T_EVP_ELEVOUCHERTYPE_L', 'FPKID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_ELEVOUCHERTYPE_L') CREATE INDEX IDX_EVP_ELEVOUCHERTYPE_L ON T_EVP_ELEVOUCHERTYPE_L ( FID ,FLOCALEID );


 EXEC P_ALTERPK 'PK_T_EVP_ORIGINSYS_L', 'T_EVP_ORIGINSYS_L', 'FPKID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_ORIGINSYS_L') CREATE INDEX IDX_EVP_ORIGINSYS_L ON T_EVP_ORIGINSYS_L ( FID ,FLOCALEID );


 EXEC P_ALTERPK 'PK_T_EVP_VOUCHERENTRY', 'T_EVP_VOUCHERENTRY', 'FENTRYID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_VOUCHERENTRY') CREATE INDEX IDX_EVP_VOUCHERENTRY ON T_EVP_VOUCHERENTRY ( FID );


 EXEC P_ALTERPK 'PK_T_EVP_EXPORTTASK', 'T_EVP_EXPORTTASK', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_EXPORTTASK') CREATE INDEX IDX_EVP_EXPORTTASK ON T_EVP_EXPORTTASK ( FNUMBER ,FORGID );


 EXEC P_ALTERPK 'PK_T_EVP_MULSOURCESYS', 'T_EVP_MULSOURCESYS', 'FPKID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_MULSOURCESYS') CREATE INDEX IDX_EVP_MULSOURCESYS ON T_EVP_MULSOURCESYS ( FID );


 EXEC P_ALTERPK 'PK_T_EVP_ORIGINSYS_CONFIG', 'T_EVP_ORIGINSYS_CONFIG', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_ORIGINSYS_CONFIG') CREATE INDEX IDX_EVP_ORIGINSYS_CONFIG ON T_EVP_ORIGINSYS_CONFIG ( FELEVOUCHERTYPEID );


 EXEC P_ALTERPK 'PK_T_EVP_QUERYINTERFACE', 'T_EVP_QUERYINTERFACE', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_QUERYINTERFACE') CREATE INDEX IDX_EVP_QUERYINTERFACE ON T_EVP_QUERYINTERFACE ( FELEVOUCHERTYPEID );


 EXEC P_ALTERPK 'PK_T_EVP_SYSPARAM', 'T_EVP_SYSPARAM', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_SYSPARAM') CREATE INDEX IDX_EVP_SYSPARAM ON T_EVP_SYSPARAM ( FKEY );


 EXEC P_ALTERPK 'PK_T_EVP_BKERRECEIVER', 'T_EVP_BKERRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_BKERRECEIVER') CREATE INDEX IDX_EVP_BKERRECEIVER ON T_EVP_BKERRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_ELEVOUCHERTYPE', 'T_EVP_ELEVOUCHERTYPE', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_ELEVOUCHERTYPE') CREATE INDEX IDX_EVP_ELEVOUCHERTYPE ON T_EVP_ELEVOUCHERTYPE ( FNUMBER );


 EXEC P_ALTERPK 'PK_T_EVP_EVTENTITY', 'T_EVP_EVTENTITY', 'FENTRYID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_EVTENTITY') CREATE INDEX IDX_EVP_EVTENTITY ON T_EVP_EVTENTITY ( FID );


 EXEC P_ALTERPK 'PK_T_EVP_ORIGINSYS', 'T_EVP_ORIGINSYS', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_ORIGINSYS') CREATE INDEX IDX_EVP_ORIGINSYS ON T_EVP_ORIGINSYS ( FNUMBER );


 EXEC P_ALTERPK 'PK_T_EVP_VOUCHER', 'T_EVP_VOUCHER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_VOUCHER') CREATE INDEX IDX_EVP_VOUCHER ON T_EVP_VOUCHER ( FBILLID ,FORGID );


 EXEC P_ALTERPK 'PK_T_EVP_BKRS', 'T_EVP_BKRS', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_BKRS') CREATE INDEX IDX_EVP_BKRS ON T_EVP_BKRS ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_EINVSPCLRECEIVER', 'T_EVP_EINVSPCLRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_EINVSPCLRECEIVER') CREATE INDEX IDX_EVP_EINVSPCLRECEIVER ON T_EVP_EINVSPCLRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_INVSPCLRECEIVER', 'T_EVP_INVSPCLRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_INVSPCLRECEIVER') CREATE INDEX IDX_EVP_INVSPCLRECEIVER ON T_EVP_INVSPCLRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_INVTLFRECEIVER', 'T_EVP_INVTLFRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_INVTLFRECEIVER') CREATE INDEX IDX_EVP_INVTLFRECEIVER ON T_EVP_INVTLFRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_EFI', 'T_EVP_EFI', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_EFI') CREATE INDEX IDX_EVP_EFI ON T_EVP_EFI ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_NTREVGPMRECEIVER', 'T_EVP_NTREVGPMRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_NTREVGPMRECEIVER') CREATE INDEX IDX_EVP_NTREVGPMRECEIVER ON T_EVP_NTREVGPMRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_ATRRECEIVER', 'T_EVP_ATRRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_ATRRECEIVER') CREATE INDEX IDX_EVP_ATRRECEIVER ON T_EVP_ATRRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_RAIRECEIVER', 'T_EVP_RAIRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_RAIRECEIVER') CREATE INDEX IDX_EVP_RAIRECEIVER ON T_EVP_RAIRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_INVORDRECEIVER', 'T_EVP_INVORDRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_INVORDRECEIVER') CREATE INDEX IDX_EVP_INVORDRECEIVER ON T_EVP_INVORDRECEIVER ( FORGID ,FBILLID );


 EXEC P_ALTERPK 'PK_T_EVP_EINVORDRECEIVER', 'T_EVP_EINVORDRECEIVER', 'FID', '1';

 IF NOT EXISTS (SELECT 1 FROM KSQL_INDEXES WHERE KSQL_INDNAME = 'IDX_EVP_EINVORDRECEIVER') CREATE INDEX IDX_EVP_EINVORDRECEIVER ON T_EVP_EINVORDRECEIVER ( FORGID ,FBILLID );
 
 
 IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_QUERYINTERFACE' AND KSQL_COL_NAME IN ('FDATASIZE')) 
 ALTER TABLE T_EVP_QUERYINTERFACE ADD (FDATASIZE INT DEFAULT 0 NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_VOUCHER' AND KSQL_COL_NAME IN ('FHASPULLBILL')) 
 ALTER TABLE T_EVP_VOUCHER ADD (FHASPULLBILL CHAR(1) DEFAULT '0' NOT NULL );

--增加归档批次号
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_BKERRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_BKERRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_VOUCHER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_VOUCHER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_BKRS' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_BKRS ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_EINVSPCLRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_EINVSPCLRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_INVSPCLRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_INVSPCLRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_INVTLFRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_INVTLFRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_EFI' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_EFI ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_NTREVGPMRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_NTREVGPMRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
 EXEC p_AlterColumn 'T_EVP_ATRRECEIVER', 'FBATCHCODE', 'NVARCHAR(255)', 'NOT NULL', '0110', ''' ''';

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_ATRRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_ATRRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
 EXEC p_AlterColumn 'T_EVP_RAIRECEIVER', 'FDEDUCTIONTAXPERIOD', 'NVARCHAR(50)', 'NOT NULL', '0110', ''' ''';

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_RAIRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_RAIRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_INVORDRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_INVORDRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_EINVORDRECEIVER' AND KSQL_COL_NAME IN ('FARCHIVEBATCHCODE')) 
 ALTER TABLE T_EVP_EINVORDRECEIVER ADD (FARCHIVEBATCHCODE NVARCHAR(255) DEFAULT ' ' NOT NULL );


 EXEC P_ALTERPK 'PK_T_EVP_DAPTRACKER', 'T_EVP_DAPTRACKER', 'FID', '1';
 EXEC p_AlterColumn 'T_EVP_EVTENTITY', 'FGBNAME', 'NVARCHAR(200)', 'NOT NULL', '0100', ''' ''';
 EXEC p_AlterColumn 'T_EVP_EVTENTITY', 'FGBNUMBER', 'NVARCHAR(200)', 'NOT NULL', '0100', ''' ''';
 EXEC p_AlterColumn 'T_EVP_QUERYINTERFACE', 'FELEVOUCHERTYPEID', 'NVARCHAR(50)', 'NOT NULL', '0110', ''' ''';
 
--凭证增加期间类型 2023年9月14日18:35:52
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_VOUCHER' AND KSQL_COL_NAME IN ('FPERIODTYPEID')) 
ALTER TABLE T_EVP_VOUCHER ADD (FPERIODTYPEID BIGINT DEFAULT 0 NOT NULL );

--对账单兼容多个原文件 2023年9月22日10:02:22
 EXEC p_AlterColumn 'T_EVP_BKRS', 'FFILEURL', 'NVARCHAR(2000)', 'NOT NULL', '0100', ''' ''';
 
 EXEC p_AlterColumn 'T_EVP_BKRS', 'FFILENAME', 'NVARCHAR(2000)', 'NOT NULL', '0100', ''' ''';
 
 EXEC p_AlterColumn 'T_EVP_BKERRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_BKERRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_EINVSPCLRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_EINVSPCLRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_INVSPCLRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_INVSPCLRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_INVTLFRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_INVTLFRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_EFI', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_EFI', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_NTREVGPMRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_NTREVGPMRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_ATRRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_ATRRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_RAIRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_RAIRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_INVORDRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_INVORDRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_EINVORDRECEIVER', 'FFILENAME', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

 EXEC p_AlterColumn 'T_EVP_EINVORDRECEIVER', 'FFILEURL', 'NVARCHAR(500)', 'NOT NULL', '0100', ''' ''';

--凭证 2023年10月8日14:40:30
 IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_EVP_VOUCHER' AND KSQL_COL_NAME ='FBILLNO')
 ALTER TABLE T_EVP_VOUCHER ADD (FBILLNO NVARCHAR(50) DEFAULT ' ' NOT NULL);
/**End D:\PDM_UPGRADE\PDM1\EVP_constraint.sql **/
